function CreateBoxGeometry(extent)
	local uScale = 0.5
	local vScale = 0.5
	
	local builder = Graphics.GeometryBuilder()
	builder:SetTexcoordCount(1)
	builder:SetTexcoordSize(0, 2)
	builder:SetNormalEnable(true)
	
	local function CreatePlane(n, b, t)
		builder:VertexNormal(n:GetNormalized())		
		
		local u = b:GetNormalized() * uScale
		local v = t:GetNormalized() * vScale
		
		local function CreateVertex(p)
	 		builder:VertexPosition(p)
		 	builder:VertexTexcoord(0, Math.Vector2(Math.Vector3_Dot(p, u), Math.Vector3_Dot(p, v)))
			return builder:AddVertex()
		end
		
		builder:AddQuad(
			CreateVertex(n - b - t), 
			CreateVertex(n - b + t),
			CreateVertex(n + b - t),
			CreateVertex(n + b + t))
	end
	
	local h = extent * 0.5
	CreatePlane(Math.Vector3(0, h.y, 0), Math.Vector3(h.x, 0, 0), Math.Vector3(0, 0, h.z))
	CreatePlane(Math.Vector3(0, -h.y, 0), Math.Vector3(h.x, 0, 0), Math.Vector3(0, 0, -h.z))
	CreatePlane(Math.Vector3(h.x, 0, 0), Math.Vector3(0, 0, -h.z), Math.Vector3(0, -h.y, 0))
	CreatePlane(Math.Vector3(-h.x, 0, 0), Math.Vector3(0, 0, h.z), Math.Vector3(0, -h.y, 0))
	CreatePlane(Math.Vector3(0, 0, h.z), Math.Vector3(h.x, 0, 0), Math.Vector3(0, -h.y, 0))
	CreatePlane(Math.Vector3(0, 0, -h.z), Math.Vector3(-h.x, 0, 0), Math.Vector3(0, -h.y, 0))

	local geometry = Graphics.Geometry()
	builder:Build(geometry)
	
	return geometry
end
