OrbitCamera = {}

function OrbitCamera:New(o)
	o = o or {}   -- create object if user does not provide one
	setmetatable(o, self)
	self.__index = self

	local game = Engine.Game_Instance()
	local world = game:GetWorld()
	self.camera = world:CreateEntity()
	self.camera:SetName("orbitCamera")
	self.camera:CreateComponent(Engine.CameraComponentType)
	game:SetActiveCamera(self.camera)
	
	self.distance = 10
	self.yaw = 1.6
	self.pitch = 0.5
	return o
end

function OrbitCamera:OnAfterUpdate()
	local m = self.lookAtEntity:GetWorldTransform()
	local at = Math.Vector3(m.m03, m.m13, m.m23)
	local direction = Math.Vector3(0, 0, self.distance)
	local r = Math.Matrix44_RotateAxis(Math.Vector3(1, 0, 0), self.pitch) * 
			  Math.Matrix44_RotateAxis(Math.Vector3(0, 1, 0), self.yaw)
	direction = r:TransformVector(direction)
	local eye = at + direction
	self.camera:SetLocalTransform(Math.Matrix44_LookAt(eye, at, Math.Vector3(0, 1, 0)):GetInverse())
end
